package com.findlaypark.db.controller;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;

import com.findlaypark.db.DBUtilities;
import com.findlaypark.model.UserData;




public class DataController {
	public UserData getUserDataDB(Connection con, String email) throws Exception {
		
		Statement stmt = null;
		ResultSet rs = null;
		UserData userData = null;
		try {
			
			String sql = "select * from UserData where email = '"
					+ email + "'";
			stmt = con.createStatement();
			rs = stmt.executeQuery(sql);
			if (rs.next()) {
				userData = new UserData(rs.getString(1));
				userData.setFirstName(rs.getString(2));
				userData.setLastName(rs.getString(3));
				userData.setPassword(rs.getString(4));
				userData.setMobileNumber(rs.getString(5));
				userData.setTelNumber(rs.getString(6));
				userData.setCompanyName(rs.getString(7));
				userData.setAddress1(rs.getString(8));
				userData.setAddress2(rs.getString(9));
				userData.setTown(rs.getString(10));
				userData.setPostcode(rs.getString(11));
				userData.setReason(rs.getInt(12));
				userData.setStatus(rs.getInt(13));
				userData.setPasswordValid(rs.getInt(14));
				userData.setCreateDate(rs.getString(15));
				userData.setAdminAccess(rs.getBoolean(16));
				userData.setLatinAccess(rs.getBoolean(17));
				userData.setAmericanAccess(rs.getBoolean(18));
				userData.setNewFundAccess(rs.getBoolean(19));
				userData.setNotes(rs.getString(20));
				userData.setLastAccessDate(rs.getString(21));
				userData.setLastIps(rs.getString(22));
			}
		} finally {
			DBUtilities.cleanUp(con, stmt, rs);
		}
		return userData;
	}

	public boolean updateUserData(Connection con, UserData userdata) throws Exception {
		
		Statement stmt = null;
		int result;
		try {
			
			System.out.println("DC.updateUserData ips = " + userdata.getLastIps());
			
			StringBuffer sql = new StringBuffer(
					"UPDATE USERDATA USERDATA SET ");
			sql.append("firstName = '").append(userdata.getFirstName())
			.append("',").append("lastName = '")
			.append(userdata.getLastName()).append("',")
			.append("password = '").append(userdata.getPassword())
			.append("',").append("mobileNumber = '")
			.append(userdata.getMobileNumber()).append("',")
			.append("telNumber = '").append(userdata.getTelNumber())
			.append("',").append("companyName = '")
			.append(userdata.getCompanyName()).append("',")
			.append("address1 = '").append(userdata.getAddress1())
			.append("',").append("address2 = '")
			.append(userdata.getAddress2()).append("',")
			.append("town = '").append(userdata.getTown()).append("',")
			.append("postcode = '").append(userdata.getPostcode())
			.append("',").append("reason = ")
			.append(userdata.getReason()).append(",")
			.append("status = ").append(userdata.getStatus())
			.append(",").append("passwordValid = ")
			.append(userdata.getPasswordLocked()).append(",")
			.append("createDate = '").append(userdata.getCreateDate())
			.append("',").append("adminAccess = ")
			.append(userdata.getAdminAccess() ? 1 : 0).append(",")
			.append("latinAccess = ")
			.append(userdata.getLatinAccess() ? 1 : 0).append(",")
			.append("americanAccess = ")
			.append(userdata.getAmericanAccess() ? 1 : 0).append(",")
			.append("newFundAccess = ")
			.append(userdata.getNewFundAccess() ? 1 : 0).append(",")
			.append("notes = '").append(userdata.getNotes())
			.append("',").append("lastAccessDate = '")
			.append(userdata.getLastAccessDate()).append("',")
			.append("lastIps = '").append(userdata.getLastIps())
			.append("'").append(" where ").append("email = '")
			.append(userdata.getEmail()).append("'");
			stmt = con.createStatement();
			result = stmt.executeUpdate(sql.toString());
		} finally {
			DBUtilities.cleanUp(con, stmt);
		}
		if (result == 1)
			return true;
		else
			return false;
	}
	
	public boolean deleteUser(Connection con, String userId) throws Exception {
		Statement stmt = null;
		int result;
		try {
			stmt = con.createStatement();
			result = stmt.executeUpdate("Delete from USERDATA where email = '"+ userId + "'");
		} finally {
			DBUtilities.cleanUp(con, stmt);
		}
		return result > 0;
	}

	public boolean createUserData(Connection con, UserData userdata) throws Exception {
		
		Statement stmt = null;
		int result;
		try {
			
			StringBuffer sql = new StringBuffer(
					"INSERT INTO USERDATA(email,firstName,lastName,password,mobileNumber,telNumber,companyName,address1,address2,town,postcode,reason,status,passwordValid,createDate,adminAccess,latinAccess,americanAccess,newFundAccess,notes,lastAccessDate,lastIps) values (")
			.append("'").append(userdata.getEmail()).append("',")
			.append("'").append(userdata.getFirstName()).append("',")
			.append("'").append(userdata.getLastName()).append("',")
			.append("'").append(userdata.getPassword()).append("',")
			.append("'").append(userdata.getMobileNumber())
			.append("',").append("'").append(userdata.getTelNumber())
			.append("',").append("'").append(userdata.getCompanyName())
			.append("',").append("'").append(userdata.getAddress1())
			.append("',").append("'").append(userdata.getAddress2())
			.append("',").append("'").append(userdata.getTown())
			.append("',").append("'").append(userdata.getPostcode())
			.append("',").append(userdata.getReason()).append(",")
			.append(userdata.getStatus()).append(",")
			.append(userdata.getPasswordLocked()).append(",")
			.append("'").append(userdata.getCreateDate()).append("',")
			.append(userdata.getAdminAccess() ? 1 : 0).append(",")
			.append(userdata.getLatinAccess() ? 1 : 0).append(",")
			.append(userdata.getAmericanAccess() ? 1 : 0).append(",")
			.append(userdata.getNewFundAccess() ? 1 : 0).append(",")
			.append("'").append(userdata.getNotes()).append("',")
			.append("'").append(userdata.getLastAccessDate())
			.append("',").append("'").append(userdata.getLastIps())
			.append("'").append(")");
			stmt = con.createStatement();
			result = stmt.executeUpdate(sql.toString());
		} finally {
			DBUtilities.cleanUp(con, stmt);
		}
		if (result == 1)
			return true;
		else
			return false;
	}
	
public ArrayList<UserData> getAllUserDataDB(Connection con) throws Exception {
		
		Statement stmt = null;
		ResultSet rs = null;
		UserData userData = null;
		ArrayList<UserData> results = new ArrayList<UserData>();
		try {
			
			String sql = "select * from UserData";
			stmt = con.createStatement();
			rs = stmt.executeQuery(sql);
			while (rs.next()) {
				userData = new UserData(rs.getString(1));
				userData.setFirstName(rs.getString(2));
				userData.setLastName(rs.getString(3));
				userData.setPassword(rs.getString(4));
				userData.setMobileNumber(rs.getString(5));
				userData.setTelNumber(rs.getString(6));
				userData.setCompanyName(rs.getString(7));
				userData.setAddress1(rs.getString(8));
				userData.setAddress2(rs.getString(9));
				userData.setTown(rs.getString(10));
				userData.setPostcode(rs.getString(11));
				userData.setReason(rs.getInt(12));
				userData.setStatus(rs.getInt(13));
				userData.setPasswordValid(rs.getInt(14));
				userData.setCreateDate(rs.getString(15));
				userData.setAdminAccess(rs.getBoolean(16));
				userData.setLatinAccess(rs.getBoolean(17));
				userData.setAmericanAccess(rs.getBoolean(18));
				userData.setNewFundAccess(rs.getBoolean(19));
				userData.setNotes(rs.getString(20));
				userData.setLastAccessDate(rs.getString(21));
				userData.setLastIps(rs.getString(22));
				results.add(userData);
			}
		} finally {
			DBUtilities.cleanUp(con, stmt, rs);
		}
		return results;
	}
	
}
