package com.findlaypark.model;

import java.io.Serializable;

public class UserData implements Serializable {
	private String email;
	private String firstName;
	private String lastName;
	private String password;
	private String mobileNumber;
	private String telNumber;
	private String companyName;
	private String address1;
	private String address2;
	private String town;
	private String postcode;
	private int reason;
	private int status;
	private int passwordValid;
	private String createDate;
	private boolean adminAccess;
	private boolean latinAccess;
	private boolean americanAccess;
	private boolean newFundAccess;
	private String notes;
	private String lastAccessDate;
	private String lastIps;

	public UserData(String email) {
		this.email = email;
	}

	public String getEmail() {
		return email;
	}

	public String getFirstName() {
		return firstName;
	}

	public String getLastName() {
		return lastName;
	}

	public String getPassword() {
		return password;
	}

	public String getMobileNumber() {
		return mobileNumber;
	}

	public String getTelNumber() {
		return telNumber;
	}

	public String getCompanyName() {
		return companyName;
	}

	public String getAddress1() {
		return address1;
	}

	public String getAddress2() {
		return address2;
	}

	public String getTown() {
		return town;
	}

	public String getPostcode() {
		return postcode;
	}

	public int getReason() {
		return reason;
	}

	public int getStatus() {
		return status;
	}

	public int getPasswordLocked() {
		return passwordValid;
	}

	public String getCreateDate() {
		return createDate;
	}

	public boolean getAdminAccess() {
		return adminAccess;
	}

	public boolean getLatinAccess() {
		return latinAccess;
	}

	public boolean getAmericanAccess() {
		return americanAccess;
	}

	public boolean getNewFundAccess() {
		return newFundAccess;
	}

	public String getNotes() {
		return notes;
	}

	public String getLastAccessDate() {
		return lastAccessDate;
	}

	public String getLastIps() {
		return lastIps;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public void setMobileNumber(String mobileNumber) {
		this.mobileNumber = mobileNumber;
	}

	public void setTelNumber(String telNumber) {
		this.telNumber = telNumber;
	}

	public void setCompanyName(String companyName) {
		this.companyName = companyName;
	}

	public void setAddress1(String address1) {
		this.address1 = address1;
	}

	public void setAddress2(String address2) {
		this.address2 = address2;
	}

	public void setTown(String town) {
		this.town = town;
	}

	public void setPostcode(String postcode) {
		this.postcode = postcode;
	}

	public void setReason(int reason) {
		this.reason = reason;
	}

	public void setStatus(int status) {
		this.status = status;
	}

	public void setPasswordValid(int passwordValid) {
		this.passwordValid = passwordValid;
	}

	public void setCreateDate(String createDate) {
		this.createDate = createDate;
	}

	public void setAdminAccess(boolean adminAccess) {
		this.adminAccess = adminAccess;
	}

	public void setLatinAccess(boolean latinAccess) {
		this.latinAccess = latinAccess;
	}

	public void setAmericanAccess(boolean americanAccess) {
		this.americanAccess = americanAccess;
	}

	public void setNewFundAccess(boolean newFundAccess) {
		this.newFundAccess = newFundAccess;
	}

	public void setNotes(String notes) {
		this.notes = notes;
	}

	public void setLastAccessDate(String lastAccessDate) {
		this.lastAccessDate = lastAccessDate;
	}

	public void setLastIps(String lastIps) {
		this.lastIps = lastIps;
	}

	public String toString() {
		StringBuffer buffer = new StringBuffer("UserData toString() ");
		buffer.append('\n' + "   email : " + getEmail());
		buffer.append('\n' + "   firstName : " + getFirstName());
		buffer.append('\n' + "   lastName : " + getLastName());
		buffer.append('\n' + "   password : " + getPassword());
		buffer.append('\n' + "   mobileNumber : " + getMobileNumber());
		buffer.append('\n' + "   telNumber : " + getTelNumber());
		buffer.append('\n' + "   companyName : " + getCompanyName());
		buffer.append('\n' + "   address1 : " + getAddress1());
		buffer.append('\n' + "   address2 : " + getAddress2());
		buffer.append('\n' + "   town : " + getTown());
		buffer.append('\n' + "   postcode : " + getPostcode());
		buffer.append('\n' + "   reason : " + getReason());
		buffer.append('\n' + "   status : " + getStatus());
		buffer.append('\n' + "   passwordValid : " + getPasswordLocked());
		buffer.append('\n' + "   createDate : " + getCreateDate());
		buffer.append('\n' + "   adminAccess : " + getAdminAccess());
		buffer.append('\n' + "   latinAccess : " + getLatinAccess());
		buffer.append('\n' + "   americanAccess : " + getAmericanAccess());
		buffer.append('\n' + "   newFundAccess : " + getNewFundAccess());
		buffer.append('\n' + "   notes : " + getNotes());
		buffer.append('\n' + "   lastAccessDate : " + getLastAccessDate());
		buffer.append('\n' + "   lastIps : " + getLastIps());
		return buffer.toString();
	}
}
