package com.findlaypark.unittests.password;

import java.util.HashMap;

import junit.framework.Assert;

import org.junit.Test;

import com.findlaypark.model.PasswordGenerator;


public class AllTests {

	
	@Test
	public void testPasswordSize() {
		for(int i = 0; i < 1000; i++) {
			String pw = PasswordGenerator.getRandomPassword();
			if(pw.length() != 10) {
				Assert.fail();
			} 
		}		
	}
	
	
	@Test
	public void test1000Unique() {
		
		HashMap<String, String> premades = new HashMap<String, String>();
		for(int i = 0; i < 1000; i++) {
			String pw = PasswordGenerator.getRandomPassword();
			if(premades.containsKey(pw)) {
				System.out.println(pw + " on iteration " + i);
				Assert.fail();
			} else {
				premades.put(pw, pw);				
			}
		}		
		
	}
		
}
